{
  description = "https://uninsane.org blog";
  inputs = {
    nixpkgs.url = "nixpkgs/nixos-22.05";
    flake-utils.url = github:numtide/flake-utils;
  };

  outputs = { self, nixpkgs, flake-utils }:
    {
      overlay = final: prev: import ./default.nix { pkgs = prev; };
    } //
    (
      with flake-utils.lib; eachSystem allSystems (system:
      let
        pkgs = import nixpkgs { inherit system; };
      in
      rec {
        packages = import ./default.nix { inherit pkgs; };
        defaultPackage = packages.uninsane-dot-org;

        devShells.default = with pkgs; mkShell {
          buildInputs = with packages.uninsane-dot-org; (buildInputs ++ nativeBuildInputs);
        };
      })
    );
}
